//
//
// O[o萔
//@VCADȒlZbgłB̏ꏊ
//
//

//-----------------------------------
// ϊs
//-----------------------------------
float4x4 mW;		// [hs@܂L̍s
float4x4 mV;		// r[s
float4x4 mP;		// ˉes

// XLbVp
static const int MAX_MATRICES = 26; // ő{[
float4x3 mWArray[MAX_MATRICES]; // {[sz
int CurNumBones = 2; // e{[

//-----------------------------------
// }eA֌W
//-----------------------------------
float4	MateDiffuse = float4(1,1,1,1);	// }eÅgU(Diffuse)F
float4	MateSpecular = float4(1,1,1,1);	// }eA̔(Specular)F  ̂悤ɔ˂Ƃ̐F
float	MateSpePower = 50;				// }eA̔(Specular)̗
float4  MateEmissive = float4(0,0,0,0); // }eA̎ȔF@̃Tvł͖gpł
// }eAAmbient͎gȂ

//-----------------------------------
// eNX`
//-----------------------------------
texture MateDiffuseTex;         // }eÃeNX`
// MateDiffuseTexp̃Tv
// ۂɃeNX`F擾ɂ́Ag
sampler MateDiffuseSmp = sampler_state
{
	Texture = <MateDiffuseTex>;
	MipFilter = LINEAR;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	AddressU = Wrap;
	AddressV = Wrap;
};


//Pxp(FƂ邩)
float3 TakeColor = float3(1, 1, 1);

//-----------------------------------
// Cg֌W
//-----------------------------------
float3 LightDir = float3(0 ,-1, 0);	    // s̕
float4 LightColor = float4(1,1,1,1);    // sDiffuseF
float4 LightSpecular = float4(1,1,1,1); // sSpecularF@LightColorƎ悤ɐFɂƗǂ

float4 LightAmbient;                    // ̐F

//-----------------------------------
// Jp
//-----------------------------------
float3 CamPos;		// JW


//
//
// 璸_VF[_
//
//

//==============================================================
// _VF[_sNZVF[_ɓnf[^p\
//==============================================================
struct VS_OUT
{
	float4 Pos		: POSITION;		// 2DW
	float2 MeshUV	: TEXCOORD0;	// eNX`UV
	
	float3 wPos		: TEXCOORD1;	// 3DW
	float3 wN		: TEXCOORD2;	// @
};

//==============================================================
// _VF[_
//	E_PĂ̂ŁAsNZVF[_ɓnB
//==============================================================
VS_OUT VS (
	float4 pos : POSITION,				// W(f̒_Ŵ܂ܗ@܂SL̍sƂlĂ܂񁁁u[JWvƂ܂)
	float3 normal : NORMAL,             // @(f̖@̂܂ܗ@܂SL̍sƂlĂ܂)
	float2 mesh_uv : TEXCOORD0			// eNX`UV
) {
	VS_OUT Out = (VS_OUT)0;		// sNZf[^ɓnf[^p\

	//-------------------------------------
	// _W2D(ˉeWn)֕ϊ
	//-------------------------------------
	Out.Pos = mul(pos, mW);     // [hϊ@L̍sŕϊ遁u[hWvƂ܂
		Out.wPos = Out.Pos.xyz;	// [hWsNZVF[_֓n
	Out.Pos = mul(Out.Pos, mV);	// r[ϊ@Jl3DWɂȂ遁ur[WvƂ܂
	Out.Pos = mul(Out.Pos, mP);	// -1`12DԂł̍WɂȂ遁uˉeWvƂ܂

	// eNX`UVŴ܂܃sNZVF[_(ϐ΁AUVXN[Ƃł)
	Out.MeshUV = mesh_uv;

	// @
	float3 w_normal = normalize(mul(normal, (float3x3)mW));	// [J@[h@ɕϊ
	Out.wN = w_normal;

	return Out;
}

//==============================================================
// XLbVp __VF[_
//==============================================================
VS_OUT SkinVS(
	float4 pos : POSITION,
	float3 normal : NORMAL,
	float2 mesh_uv : TEXCOORD0,

	float4 BlendWeights : BLENDWEIGHT, // {[EFCg
	float4 BlendIndices : BLENDINDICES, // {[CfbNX
	uniform int NumBones
)
{
    VS_OUT Out;

	//===================================================
	// _W@Ã{[sō
	//===================================================
    float3 Pos = 0.0f;
    float3 Normal = 0.0f;
    float LastWeight = 0.0f;

	// ÂO{̑Ήׂ̈̕ϊ(݂̃O{Ȃ炷KvȂAꉞĂ)
    int4 IndexVector = D3DCOLORtoUBYTE4(BlendIndices);

	// d݂gpčWƖ@vZAd݂~ςĂB
    for (int iBone = 0; iBone < NumBones - 1; iBone++)
    {
        LastWeight += BlendWeights[iBone];

        Pos += mul(pos, mWArray[IndexVector[iBone]]) * BlendWeights[iBone];
        Normal += mul(normal, (float3x3) mWArray[IndexVector[iBone]]) * BlendWeights[iBone];
    }

    LastWeight = 1.0f - LastWeight;
	// ŏIIȉe
    Pos += (mul(pos, mWArray[IndexVector[NumBones - 1]]) * LastWeight);
    Normal += (mul(normal, mWArray[IndexVector[NumBones - 1]]) * LastWeight);
	//===================================================

	// 3DW
    Out.wPos = Pos;

	// 3DWr[sƎˉesŕϊ2DW
    Out.Pos = mul(float4(Pos, 1), mV);
    Out.Pos = mul(Out.Pos, mP);
	
	// @
    Out.wN = normalize(Normal);

	// eNX`UV
    Out.MeshUV = mesh_uv;

    return Out;
}

//
//
// sNZVF[_
//
//

//==================================================================
// sNZVF[_o͂f[^p\
//==================================================================
struct PS_OUT
{
	float4 Color : COLOR0;  // o͐F(RenderTarget0Ԗڂɏo͂)
	float4 Bloom : COLOR1;  // o͐F(RenderTarget1Ԗڂɏo͂)
};

// sNZVF[_
//	EsNZ̐F肵A̐FԂ(R,G,B,Afloat4^)
PS_OUT PS(VS_OUT In)
{
	// @𐳋K
	float3 w_normal = normalize(In.wN);

	//=========================================================================
    //
	// fF c ̃sNZł̃f̍ގ̐F߂Bʏ̓}eAFƃeNX`F̂łB
    //
	//=========================================================================
	float4 texCol = tex2D(MateDiffuseSmp, In.MeshUV); // eNX`F擾
	float4 modelCol = MateDiffuse * texCol; // }eA̐F * eNX`̐F

	// At@eXg(eNX`̓xȉƁÃsNZF͏o͂Ȃ)
	if (texCol.a < 0.1)discard;

	//=========================================================================
    //
    // CgF c ̃sNZ󂯂郉Cg̐F߂B
    //
	//=========================================================================

    //------------------------------------------------
	// sł̃CeBO(o[gƖ) c sł́ugUv̐FZoB
    //------------------------------------------------
	float LPow = dot(-LightDir, w_normal);	// ̋ -1`1
	LPow = saturate(LPow); // 0`1Ɏ߂ LPowÃsNZɓ̋ɂȂ@00%  1100%

	float4 lightCol = LightColor * LPow;    // ̐F * ̋
	lightCol.a = 1;                         // At@͂PŒ

    //------------------------------------------------
	// F c ǂȏԂł΂ɓ̂ƁBꂪƈÂ肷B
    //------------------------------------------------
	// Ԃ񃉃CgFZ
	lightCol += LightAmbient;
	
    //------------------------------------------------
	// XyL c ̂悤ɔ˂B
    //------------------------------------------------
	float3 vCam = normalize( CamPos - In.wPos );		// (J)ւ̕
	float3 vRef = LightDir + 2.0f * dot( w_normal, -LightDir ) * w_normal;
	float spePow = pow(max(0,dot(vCam,vRef)), MateSpePower);
	float4 lightSpe = LightSpecular * spePow;

	//================================================
	// Fo
	//================================================

	// ŏIIȐFZo
	float4 diffuseCol = lightCol * modelCol;    // gU̓f̊gUFɉeBŏIIȊgU(Diffuse)F߂B
	float4 speCol = lightSpe * MateSpecular;    // ˌ̓f̔ːFɉeBŏIIȔ(Specular)F߂B

	PS_OUT Out;
	Out.Color = diffuseCol + speCol; // gUF + ːF
//    Out.Color.rgb = LPow;
 //   Out.Color.a = 1;

 //	PxF
	Out.Bloom.rgb = max(0, Out.Color.rgb-TakeColor);//	max( a , b )@ab̑傫قԂ
	Out.Bloom.a = 1;

	return Out;
}



//
// eNjbN
//  `̏ڍׂ܂Ƃ߂́B
//  ܂Agp_VF[_ƃsNZVF[_w肵A
//  RenderStatew肵łB
//
//  VĆÃeNjbNgĕ`sɂȂ
//

// XLbVpeNjbN
VertexShader SkinVSArray[5] =
{
    compile vs_3_0 VS(),        // XLjOȂ_VF[_
    compile vs_3_0 SkinVS(1),   // 1{[ł̃XLjO_VF[_
	compile vs_3_0 SkinVS(2),   // 2{[ł̃XLjO_VF[_
	compile vs_3_0 SkinVS(3),   // 3{[ł̃XLjO_VF[_
	compile vs_3_0 SkinVS(4)    // 4{[ł̃XLjO_VF[_
};

technique Tech
{
	pass P0 {
//		VertexShader = compile vs_3_0 VS();   // _VF[_VS()g
        VertexShader = (SkinVSArray[CurNumBones]); // CurNumBonesɂĒ_VF[_I
		PixelShader = compile ps_3_0 PS();    // sNZVF[_PS()g
	}
}
